/*
   This file provides practice with the operations described in Section 4.2.

   Follow the directions in this file to implement each of the
   following linked list operations on a singly linked list
   with a head and a tail pointer:
      insert into an empty list,
      insert at the beginning of the list,
      delete at the beginning of the list,
      insert at the end of the list,
      insert after a selected item in the list,
      delete after a selected item in the list.

   Note: The operation
      delete at the end of the list
   is doable, but it is a slow operation and the
   tail pointer DOES NOT help you do the operation.
   Similarly, the operation
      delete a selected item in the list
   is also doable, but it is a slow operation.

   Use the jGrasp IDE to single step through this program
   in the debugger and watch that it does the correct steps
   for each of the following linked list operator.
*/


/**
   This is a simplified version of the
   IntNode class from the textbook.

   This version does not have any of the "linked list"
   methods that don't really belong in the Node class.
*/
class IntNode
{
   private int data;
   private IntNode link;

   public IntNode(int data, IntNode link)
   {
      this.data = data;
      this.link = link;
   }

   public int     getData( )            { return data; }
   public IntNode getLink( )            { return link; }
   public void    setData(int data)     { this.data = data; }
   public void    setLink(IntNode link) { this.link = link; }
}//IntNode



/**
   Follow the directions below to implement each of the
   eight possible linked list operations on a singly linked
   list with a head and a tail pointer.
*/
public class PracticeWithLinkingNodes
{
   public static void main(String[ ] args)
   {
      // Create an empty, singly linked list with a head and a tail reference.
      IntNode head = null;
      IntNode tail = null;

      // 1.) Insert a node with data 100 into this empty list.




      // 2.) Insert a node with data 200 at the beginning of the list.




      // 3.) Insert a node with data 300 at the end of the list.




      IntNode cursor = null;
      // The list now has three nodes. Move the cursor to the middle node.
      cursor = head.getLink();


      // 4.) Insert a node with data 400 after the cursor (but don't move the cursor).




      // The list should now be [200, 100, 400, 300], with the
      // cursor still pointed at the node containing 100.

      // 5.) Delete the node pointed to by the cursor. Then nullify the cursor.




      // 6.) Delete the first node in the list (the one containing 200).




      // 7.) Delete the last node in the list (the one containing 300).




      // 8.) Delete the single remaining node from the list (the one containing 400).




      // Make sure that head and tail are both null.
      if ( (head != null) || (tail != null) )
         System.out.println("You did something wrong.");

   }//main()
}//PracticeWithLinkingNodes
